lots of updates, some t11 stuff
[distro-setup] / distro-begin
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 # for setting up a new machine
17 # usage: $0 [-r] [HOSTNAME]
18 # HOSTNAME changes the machine's hostname
19
20 # tips:
21 # run any sudo command first so your pass is cached
22 # set the scrollback to unlimited in case something goes wrong
23
24
25 # send to registrar, glue records:
26 # for iankelling.org:
27
28 # ns1.iankelling.org 72.14.176.105
29 # ns1.iankelling.org 2600:3c00::f03c:91ff:fe6d:baf8
30 # ns2.iankelling.org 172.105.84.95
31 # ns2.iankelling.org 2a01:7e01::f03c:91ff:feb5:baec
32
33 # for zroe.org:
34
35 # ns1.zroe.org 72.14.176.105
36 # ns1.zroe.org 2600:3c00::f03c:91ff:fe6d:baf8
37 # ns2.zroe.org 172.105.84.95
38 # ns2.zroe.org 2a01:7e01::f03c:91ff:feb5:baec
39 #
40
41
42
43 ####### begin setup environment #######
44
45
46 ### make ssh interactive shell run better. for when running line interactively line by line
47 sudo bash -c '/a/exe/ssh-emacs-setup'
48
49 ##### setup error handling
50 interactive=true # set this to false to force set -x
51 [[ $- == *i* ]] || interactive=false
52 if ! $interactive; then
53 set -x
54 fi
55 source /a/bin/errhandle/err
56
57 mkdir -p ~/.local
58 err-cleanup() {
59 echo 1 >~/.local/distro-begin
60 }
61
62 source /a/bin/distro-functions/src/package-manager-abstractions
63
64 ### setup logging
65 echo "$0: $(date): starting now)"
66
67
68 ### sanity checking
69 if [[ $EUID == 0 ]]; then
70 if getent passwd iank || getent passwd ian ; then
71 echo "$0: error: running as root. unprivileged user exists. use it."
72 exit 1
73 else
74 echo "$0: warning: running as root. I will setup users then exit"
75 fi
76 fi
77
78
79 ### arg parsing
80 recompile=false
81 emacs=false
82 if [[ -e /a/opt/emacs ]]; then
83 emacs=true
84 fi
85 while [[ $1 == -* ]]; do
86 case $1 in
87 -r) recompile=true; shift ;;
88 -e) emacs=false; shift ;;
89 esac
90 done
91 if [[ $1 ]]; then
92 export HOSTNAME=$1
93 fi
94
95
96 ##### variables/env setup
97 script_dir="$(readlink -f "${BASH_SOURCE[@]}")"; script_dir=${script_dir%/*}
98 # shellcheck source=./pkgs
99 source $script_dir/pkgs
100 set +x
101 source /a/bin/distro-functions/src/identify-distros
102 $interactive || set -x
103 for f in kd x2 x3 frodo tp li bk je demohost kw sy bo; do
104 eval "$f() { [[ $HOSTNAME == $f ]]; }"
105 done
106 codename=$(debian-codename)
107 bitfolk() { je || bk; }
108 has_wayland() { has_monitor && [[ $codename == buster ]]; }
109 has_x() { has_monitor && [[ $codename != buster ]]; }
110 has_monitor() { ! vps ; }
111 vps() { bitfolk || li; }
112 # linode actually has btrfs now, but we dont do anything with it.
113 has_btrfs() { ! vps; }
114 home_network() { ! vps && ! tp; }
115 has_p() { ! vps && ! tp; }
116 encrypted() { ! bitfolk; }
117 shopt -s extglob
118 export GLOBIGNORE="*/.:*/.."
119 umask 022
120 PATH="/a/exe:$PATH"
121 sed="sed --follow-symlinks"
122
123 ####### end setup environment #######
124
125
126 ##### begin setup encryption scripts ######
127 if encrypted; then
128 # I tried making a service which was dependent on reboot.target,
129 # but it happened too late in the shutdown process.
130 sudo dd of=/etc/systemd/system/keyscripton.service <<'EOF'
131 [Unit]
132 Description=keyscripton
133 # This is triggered by reboot and when keyscriptoff stops.
134
135 # tried using graphical.target, but it made my display manager restart before rebooting.
136 # generally, I don't think targets order shutdown like they do startup.
137 # So, I did systemd-analyze plot > something.svg, and picked a reliably started
138 # service that happens late in the game.
139 After=ntp.service
140 DefaultDependencies=no
141 # not sure if needed, makes sure we shut down before reboot.target
142 Conflicts=reboot.target
143
144 [Service]
145 Type=oneshot
146 RemainAfterExit=yes
147 ExecStart=/bin/true
148 ExecStop=/a/exe/keyscript-on
149
150 [Install]
151 WantedBy=keyscriptoff.service
152 EOF
153 sudo systemctl daemon-reload # needed if the file was already there
154 sudo systemctl enable keyscripton.service
155
156 sudo dd of=/etc/systemd/system/keyscriptoff.service <<'EOF'
157 [Unit]
158 Description=keyscriptoff
159
160 [Service]
161 Type=oneshot
162 ExecStart=/a/exe/keyscript-off
163
164 [Install]
165 WantedBy=multi-user.target
166 EOF
167 sudo systemctl daemon-reload # needed if the file was already there
168 sudo systemctl enable keyscriptoff.service
169 sudo systemctl start keyscriptoff.service
170
171 pi rsync zstd
172
173 ## /usr/share/doc/dropbear-initramfs/README.initramfs.gz
174 ## claims we need to do this. but it works fine without it.
175 # tmp=$(mktemp)
176 # while read -r m _; do /sbin/modinfo -F filename "$m"; done </proc/modules | \
177 # sed -nr "s@^/lib/modules/$(uname -r)/kernel/drivers/net(/.*)?/([^/]+)\.ko\$@\2@p" \
178 # | sudo dd of=$tmp
179 # if ! diff -q /etc/initramfs-tools/modules $tmp &>/dev/null; then
180 # sudo dd if=$tmp of=/etc/initramfs-tools/modules
181 # sudo /usr/sbin/update-initramfs -u -k all
182 # fi
183 #
184 ## if we were creating an intall for a different machine needing different modules, we could include them all like this:
185 ## find /lib/modules/*/kernel/drivers/net /lib/modules/*/kernel/net -type f -name '*.ko' -printf "%f\n" | sed 's/.ko$//' | sort -u >/etc/initramfs-tools/modules
186
187 # this is here to cleanup the leftover from the comments above. remove it eventually.
188 if [[ -s /etc/initramfs-tools/modules ]]; then
189 sudo truncate -s0 /etc/initramfs-tools/modules
190 sudo /usr/sbin/update-initramfs -u -k all
191 fi
192
193 # initram auth keys get setup with rootsshsync later on.
194 $script_dir/rootsshsync
195
196 ### To do a remote unlock: ssh and do this once per crypt disk:
197 # echo -n PASS >/lib/cryptsetup/passfifo
198 # or for buster+
199 # cryptroot-unlock
200
201 fi
202 ##### end setup encryption scripts ######
203
204
205 # disabled until its fixed up
206 # install-myqueue
207
208 # todo, it would be nice to cut down on some of the output
209
210
211 #### rerun my fai-time scripts
212 # already ran for pxe installs, but used for vps & updates
213 distro=$(distro-name)
214 case $distro in
215 ubuntu|debian|trisquel)
216 sudo bash -c ". /a/bin/fai/fai-wrapper && /a/bin/fai/fai/config/scripts/IANK/11-iank"
217 ;;
218 *)
219 sudo bash -c ". /a/bin/fai/fai-wrapper &&
220 /a/bin/fai/fai/config/distro-install-common/end"
221 ;;
222 esac
223
224 ###### setup hostname
225 if [[ $HOSTNAME != $(cat /etc/hostname) ]]; then
226 echo $HOSTNAME > /etc/hostname
227 hostname -F /etc/hostname
228 fi
229 # office vpn dhcp adds to /etc/resolv.conf search office.fsf.org which
230 # makes that be #1 priority, which makes dnsmasq resolve that for
231 # unqualified hosts first, which means we skip the hosts file. Ya, its
232 # kinda dumb, but it is what it is. There is a dnsmasq config option to
233 # override it too, but this seems simpler.
234 sudo sed -i --follow-symlinks -f - /etc/hosts <<EOF
235 \$a 127.0.1.1 $HOSTNAME.b8.nz $HOSTNAME.office.fsf.org $HOSTNAME
236 /^127\.0\.1\.1/d
237 EOF
238
239 ##### exit first stage if running as root
240 if [[ $EUID == 0 ]]; then
241 if [[ ! -e /home/iank/.ssh/authorized_keys && ! -L /home/iank/.ssh/authorized_keys ]]; then
242 sudo -u iank mkdir -p /home/iank/.ssh
243 chmod 0700 /home/iank/.ssh
244 sudo -u iank ln -sf /p/c/machine_specific/vps/subdir_files/.ssh/authorized_keys /home/iank/.ssh
245 fi
246 echo "$0: running as root. exiting now that users are setup"
247 exit 0
248 fi
249
250
251 #### setup bash for root
252 for x in /a/c/{.bashrc,brc,brc2,.bash_profile,.profile,.inputrc,path_add_function}; do
253 sudo -i <<EOF
254 PATH="/a/exe:$PATH"
255 lnf $x /root
256 EOF
257 done
258
259 ###### link files
260 # convenient to just do all file linking in one place
261 sudo /a/exe/lnf -T /a/bin /b
262 sudo /a/exe/lnf -T /a/f /f
263 sudo /a/exe/lnf -T /var/log/exim4 /el
264 sudo /a/exe/lnf -T /a/f/ans /c
265 sudo /a/exe/lnf -T /nocow/t /t
266 if has_p; then
267 lnf -T /p/News ~/News
268 fi
269 dirs=(/q/root /q/root/.editor-backups /q/root/.undo-tree-history)
270 sudo mkdir -p ${dirs[@]}
271 sudo chmod 600 ${dirs[@]}
272 sudo /a/exe/lnf /q/root/.editor-backups /q/root/.undo-tree-history \
273 /a/opt /a/c/.emacs.d $HOME/mw_vars /k/backup /root
274 /a/bin/ds/install-my-scripts # needed for rootsshsync cronjob
275 sudo /a/exe/lnf /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
276
277
278 ###### do conflink
279 # vps needs bind group before conflink
280 if vps; then
281 pi-nostart bind9
282 fi
283 if bitfolk; then
284 pi-nostart unbound
285 fi
286 # this needs to be before installing pacserve so we have gpg conf.
287 conflink
288 rootsshsync
289 if [[ -e /etc/rootsudoenv ]]; then
290 source /etc/rootsudoenv
291 fi
292
293
294
295 ###### bash environment setup
296 set +x
297 err-allow
298 source /etc/profile.d/environment.sh
299 export LC_USEBASHRC=t
300 # shellcheck source=./.bashrc
301 source ~/.bashrc
302 err-catch
303 $interactive || set -x
304
305 ##### use systemd-resolved for glibc resolutions
306
307 pi libnss-resolve
308
309 if [[ ! -L /etc/nsswitch.conf ]]; then
310 sudo mkdir -p /etc/resolved-nsswitch
311 sudo mv /etc/nsswitch.conf /etc/resolved-nsswitch
312 sudo ln -sf /etc/resolved-nsswitch/nsswitch.conf /etc
313 fi
314
315 f=/etc/basic-nsswitch/nsswitch.conf
316 if [[ ! -e $f ]]; then
317 sudo mkdir -p ${f%/*}
318 sudo cp /etc/nsswitch.conf $f
319 sudo sed -i --follow-symlinks 's/^ *hosts:.*/hosts: files dns myhostname/' $f
320 fi
321 case $HOSTNAME in
322 bk|je)
323 # je should be able to get along systemd-resolved, but ive had some odd
324 # very intermittent dns failures with spamassassin, it seems it might only
325 # be happening with systemd-resolved, so just use unbound
326 # to make it consistent with the other hosts.
327 sudo sed -i --follow-symlinks 's/^ *hosts:.*/hosts: files dns myhostname/' /etc/nsswitch.conf
328 soff systemd-resolved
329 sudo ln -sf 127.0.0.1-resolv/stub-resolv.conf /etc/resolv.conf
330 sgo unbound
331 # cautious measure to make sure resolution is working
332 sleep 1
333 ;;
334 *)
335 # default is
336 # files mdns4_minimal [NOTFOUND=return] dns myhostname
337 # mdns4 is needed for my printer and for bbb webrtc, not sure exactly why.
338 # https://www.freedesktop.org/software/systemd/man/nss-resolve.html#
339 # seems more important than some potential use case.
340 # Interestingly, t9/t10 man page says use files before resolve, debian 10 says the opposite.
341 # removing files makes hostname -f not actually give the fully qualified domain name.
342 sudo sed -i --follow-symlinks 's/^ *hosts:.*/hosts: files resolve [!UNAVAIL=return] mdns4_minimal [NOTFOUND=return] myhostname/' /etc/resolved-nsswitch/nsswitch.conf
343 ;;
344 esac
345
346 case $HOSTNAME in
347 bk)
348 sgo named
349 ;;
350 esac
351
352
353 f=/etc/apparmor.d/abstractions/nameservice
354 if [[ -e $f ]] && ! grep -q /etc/resolved-nsswitch/nsswitch.conf $f; then
355 sudo sed -i '/\/etc\/nsswitch.conf/a /etc/resolved-nsswitch/nsswitch.conf r,' $f
356 sudo sed -i '/\/etc\/nsswitch.conf/a /etc/basic-nsswitch/nsswitch.conf r,' $f
357 if sytemctl is-enabled apparmor; then
358 m ser reload apparmor
359 fi
360 fi
361
362
363
364 if dpkg -s -- nscd &>/dev/null; then
365 sudo apt-get -y remove --purge --auto-remove nscd
366 sudo systemctl stop nscd ||: # fails if already stopped
367 fi
368
369 # http://strugglers.net/~andy/blog/2020/12/03/starting-services-only-when-the-network-is-ready-on-debiansystemd/
370 if systemctl cat ifupdown-wait-online.service &>/dev/null; then
371 sudo systemctl enable ifupdown-wait-online.service
372 fi
373
374 if bitfolk; then
375 # remove line like this: 85.119.82.128 je.iankelling.org je
376 # it messes with hostname -f.
377 sudo sed -ri "/^127\./n;/[[:space:]]$HOSTNAME\$/d" /etc/hosts
378 fi
379
380 if isdeb && [[ $(debian-codename) == nabia ]]; then
381 sudo dd of=/etc/apt/preferences.d/aramo-jammy-missing <<'EOF'
382 Package: linux-libc-dev libmysqlclient21
383 Pin: release n=jammy,o=Ubuntu
384 Pin-Priority: 500
385 EOF
386 fi
387
388 # libfdk just has some patent worries.
389 # https://www.gnu.org/licenses/license-list.en.html#fdk
390 if isdeb && [[ $(debian-codename) == nabia ]]; then
391 sudo dd of=/etc/apt/preferences.d/nabia-focal-missing <<'EOF'
392 Package: libfdk-aac1
393 Pin: release n=focal,o=Ubuntu
394 Pin-Priority: 500
395 EOF
396
397 # it has a dependency python-paramiko that should be
398 # python3-paramiko. the backport version is pretty close to the normal
399 # version, so i just set the pin priority low for the backport and it
400 # doesnt bother me
401 sudo dd of=/etc/apt/preferences.d/nabia-backport <<'EOF'
402 Package: ansible
403 Pin: release a=nabia-backports
404 Pin-Priority: -100
405 EOF
406
407 fi
408
409
410 # to test when these become available in trisquel, copy the package list, remove the * chars, repaplace PACKAGES below
411 # for x in PACKAGES; do hr; e $x; if [[ $x == *- ]]; then s="^$x"; dpkg -l "$x*" | sed '0,/^+++/d'; else s="^$x\$"; fi; aptitude search "~O Trisquel ~n $s"; done
412
413
414 #### setup firefox backport
415 ## ian: disabled. backports are not being published atm due to rust packaging issue
416 # if isdeb; then
417 # codename=$(debian-codename)
418 # if isdebian-stable && has_x; then
419 # s dd of=/etc/apt/sources.list.d/mozilla-iceweasel.list <<EOF
420 # deb http://mozilla.debian.net/ $codename-backports firefox-release
421 # deb-src http://mozilla.debian.net/ $codename-backports firefox-release
422 # EOF
423 # p update
424 # # take care of mozilla signing errors in previous command
425 # pi pkg-mozilla-archive-keyring
426 # fi
427 # p update
428 # fi
429
430
431 ###### arch aur wrapper setup
432 if isarch; then
433 #https://wiki.archlinux.org/index.php/Arch_User_Repository#Installing_packages
434 sudo pacman -S --noconfirm --needed base-devel jq
435 # pacaur seems to be the best, although it + cower has a few minor bugs,
436 # its design goals seem good, so, going for it.
437
438 aurpi() {
439 for p in "$@"; do
440 tempdir=$(mktemp -d)
441 pushd $tempdir
442 aurex "$p"
443 makepkg -sri --skippgpcheck --noconfirm
444 popd
445 rm -rf $tempdir
446 done
447 }
448 aurpi cower pacaur
449
450 pi pacserve
451
452 x=$(mktemp); /usr/bin/pacman.conf-insert_pacserve >$x
453 sudo dd of=/etc/pacman.conf if=$x; rm $x
454 sudo systemctl enable pacserve.service
455 sudo systemctl start pacserve.service
456
457 fi
458
459 #### update all packages
460 pup
461
462
463 ###### p1 packages install ######
464 pi ${p1[@]}
465
466
467 ######## fix evbug bug ######
468 case $(debian-codename-compat) in
469 xenial|bionic|focal)
470 # noticed in flidas. dunno if it affects any others
471 #https://bugs.launchpad.net/ubuntu/+source/module-init-tools/+bug/240553
472 #https://wiki.debian.org/KernelModuleBlacklisting
473 #common advice when searching is to use /etc/modprobe.d/blacklist.conf,
474 #but that file won't work and will get automatically reverted
475 sudo rmmod evbug ||: # might not be loaded yet
476 file=/etc/modprobe.d/evbug.conf
477 line="blacklist evbug"
478 if [[ $(cat $file) != "$line" ]]; then
479 sudo dd of=$file 2>/dev/null <<<"$line"
480 sudo depmod -a
481 sudo update-initramfs -u
482 fi
483 ;;
484 esac
485
486
487
488 #### arch specific early packages
489 case $(distro-name) in
490 arch)
491 # pkgfile is like apt-cache
492 pi pkgfile
493 sudo pkgfile --update
494 ;;
495 esac
496
497 #### enable trim
498 # enable trim for volume delete, other rare commands
499 sudo $sed -ri 's/( *issue_discards\b).*/\1 = 1/' /etc/lvm/lvm.conf
500 if encrypted; then
501 # flidas or so, these units arent built-in
502 if isdeb && ! systemctl list-unit-files | grep ^fstrim.timer &>/dev/null ; then
503 sudo cp /usr/share/doc/util-linux/examples/fstrim.{service,timer} /etc/systemd/system
504 fi
505 # does weekly trim
506 sudo systemctl enable fstrim.timer
507 fi
508
509 ##### make extra dirs
510 dirs=()
511 for dir in /mnt/{1,2,3,4,5,6,7,8,9} /nocow/t; do
512 [[ -e $dir ]] && continue
513 dirs+=($dir)
514 done
515 if (( ${#dirs[@]} )); then
516 # mkdir -p on a mounted directory will fail. so will chown if its an ro mount
517 sudo mkdir -p "${dirs[@]}"
518 sudo chown $USER:$USER "${dirs[@]}"
519 fi
520
521
522 # disabled temporarily
523 ###### setup /i
524 # if home_network; then
525 # tu /etc/fstab <<'EOF'
526 # /i/w /w none bind,noauto 0 0
527 # /i/k /k none bind,noauto 0 0
528 # EOF
529 # if ! mountpoint /kr; then
530 # sudo mkdir -p /kr
531 # sudo chown $USER:user2 /kr
532 # fi
533 # if [[ $HOSTNAME == frodo ]]; then
534 # tu /etc/fstab <<'EOF'
535 # /k /kr none bind,noauto 0 0
536 # EOF
537 # else
538 # tu /etc/fstab <<'EOF'
539 # frodo:/k /kr nfs noauto 0 0
540 # EOF
541 # fi
542 # sudo mkdir -p /i/{w,k}
543 # for dir in /{i,w,k}; do
544 # if mountpoint $dir; then continue; fi # already mounted
545 # sudo mkdir -p $dir
546 # sudo chown $USER:$USER $dir
547 # done
548 # # debian auto mounting of multi-disk encrypted btrfs is busted. It is
549 # # in jessie, and in stretch as of 11/26/2016 I have 4 disks in cryptab,
550 # # based on 3 of those, it creates .device units for /dev/mapper/dev...
551 # # then waits endlessly for them on bootup, after the /dev/mapper disks
552 # # have already been created and exist. todo: create a simple repro
553 # # for this in a vm and report it upstream.
554 # pi nfs-common
555 # sudo dd of=/root/imount <<'EOF'
556 # #!/bin/bash
557 # [[ $EUID == 0 ]] || exec sudo -E "${BASH_SOURCE[0]}" "$@"
558 # set -eE -o pipefail
559 # trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
560 # for dir in /i /k /kr /w; do
561 # if ! mountpoint $dir &>/dev/null && \
562 # awk '{print $2}' /etc/fstab | grep -xF $dir &>/dev/null; then
563 # if awk '{print $3}' /etc/fstab | grep -xF nfs &>/dev/null; then
564 # mount $dir || echo "warning: failed to mount nfs on $dir"
565 # else
566 # mount $dir
567 # fi
568 # fi
569 # done
570 # EOF
571 # sudo chmod +x /root/imount
572 # sudo dd of=/etc/systemd/system/imount.service <<EOF
573 # [Unit]
574 # Description=Mount /i and related mountpoints
575 # Before=syncthing@$USER.service
576
577 # [Service]
578 # Type=oneshot
579 # ExecStart=/root/imount
580
581 # [Install]
582 # RequiredBy=syncthing@$USER.service
583 # # note /kr needs networking, this target is the simplest way to
584 # # time it when the network should be up, but not do something
585 # # dumb like delay startup until the network is up. It happens
586 # # at some time after network.target
587 # WantedBy=multi-user.target
588 # EOF
589 # sudo systemctl daemon-reload # needed if the file was already there
590 # sudo systemctl enable imount.service
591 # sudo systemctl start imount.service
592 # fi
593 ###### end setup /i
594
595 ##### setup /nocow.
596 # a nocow dir that is common to multiple distros installed on the same system
597 dir=/nocow
598 if has_btrfs; then
599 if ! mountpoint $dir; then
600 subvol=/mnt/root/nocow
601 if [[ ! -e $subvol ]]; then
602 sudo btrfs subvolume create $subvol
603 sudo chown root:1000 $subvol
604 sudo chattr +C $subvol
605 fi
606
607 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
608 tu /etc/fstab <<EOF
609 $first_root_crypt /nocow btrfs noatime,subvol=nocow$( ((`nproc` > 2)) && echo ,compress=zstd ) 0 0
610 EOF
611 sudo mkdir -p $dir
612 sudo chown $USER:$USER $dir
613 sudo mount $dir
614 fi
615 else
616 sudo mkdir -p $dir
617 fi
618
619 case $HOSTNAME in
620 kd)
621 tu /etc/fstab <<'EOF'
622 /dev/mapper/crypt_dev_ata-Samsung_SSD_870_QVO_8TB_S5VUNG0N900656V-part7 /d btrfs nofail,x-systemd.device-timeout=30s,x-systemd.mount-timeout=30s,noatime,compress=zstd,subvol=d 0 0
623 EOF
624 if ! mountpoint /d &>/dev/null; then
625 sudo mkdir -p /d
626 if [[ -d /mnt/r7/d ]]; then
627 sudo mount /d
628 fi
629 fi
630 ;;
631 esac
632
633 if bitfolk; then
634 sudo systemctl disable systemd-networkd
635 fi
636
637 ##### setup email
638 primary-setup
639
640 #### ubuntu nicety
641 if isubuntu; then
642 # disable crash report annoying dialogs.
643 sudo dd of=/etc/default/apport <<<'enabled=0'
644 fi
645
646 ##### install laptop hardware packages
647 if tp || x2 || x3 || bo || sy; then
648 case $distro in
649 debian)
650 pi task-laptop
651 ;;
652 ubuntu|trisquel)
653 # the exact packages that task-laptop would install, since ubuntu
654 # doesn\'t have this virtual in practice package.
655 pi avahi-autoipd bluetooth powertop iw wireless-tools wpasupplicant
656 ;;
657 # todo: other distros unknown
658 esac
659 fi
660
661 if has_monitor; then
662
663 # sway not packaged for t9, not bothering to build it yet since
664 # i3 doesnt seem to tear and stutter on video anymore.
665 if [[ $codename == buster ]]; then
666 pi sway xwayland
667 fi
668
669
670 ###### install X
671 # no recommends due to this bug: https://trisquel.info/en/issues/26525
672 pi --no-install-recommends i3
673
674 ##### install xinput
675 case $(distro-name) in
676 trisquel|ubuntu|debian)
677 pi xinput
678 ;;
679 esac
680
681 # recommends gets us geoclue (for darkening automatically at night i assume),
682 # which recommends modemmanager, which is annoying to fix for the model01 keyboard.
683 # commented because I dont use it much, and in nabia its named changed to redshift-gtk
684 #pi --no-install-recommends gtk-redshift
685
686 ##### setup X autostart
687 # install for multiple display managers in case we use one
688 dir=/etc/X11/xinit/xinitrc.d/
689 sudo mkdir -p $dir
690 sudo cp /a/bin/distro-setup/desktop-20-autostart.sh $dir
691 s teeu /etc/systemd/logind.conf <<'EOF'
692 HandleLidSwitch=
693 EOF
694
695 # this works on
696 dir=/etc/gdm3
697 sudo mkdir -p $dir/PostLogin
698 sudo cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
699 sudo mkdir -p /etc/lightdm/lightdm.conf.d
700 # etiona lightdm.log:
701 # [SeatDefaults] is now called [Seat:*], please update this configuration
702 sudo dd of=/etc/lightdm/lightdm.conf.d/12-iank.conf <<'EOF'
703 [Seat:*]
704 display-setup-script=/a/bin/ds/lightdm-start
705 session-setup-script=/a/bin/distro-setup/desktop-20-autostart.sh
706 EOF
707
708
709 # originally used xkbcomp, documented in input-setup.sh, this doesnt
710 # work under wayland, but its still useful for creating the config,
711 # then modifying the system files.
712 sudo sed -i.orig '/key *<KPMU> *{/,/}/s/KP_Multiply/underscore/g' /usr/share/X11/xkb/symbols/keypad
713
714 ##### basic graphical packages
715 pi konsole suckless-tools ssh-askpass
716 fi
717
718
719
720 ##### install emacs
721 if $emacs; then
722 if isarch; then
723 # emacs git build was broken last time i checked,
724 x=$(mktemp -d)
725 pushd $x
726 aurex emacs-git
727 makepkg -si --noconfirm
728 popd
729 rm -rf $x
730 pi hunspell hunspell-en
731 else
732 if $recompile; then
733 /a/bin/buildscripts/emacs
734 else
735 /a/bin/buildscripts/emacs --no-r
736 fi
737 fi
738 # the first pup command can kill off our /etc/ mod, so rerun this
739 /a/exe/ssh-emacs-setup
740 fi
741
742 if [[ $HOSTNAME == kd ]] && ! mountpoint /d &>/dev/null; then
743 cat <<'EOFOUTER'
744 # if this is a fresh reinstall, need to run something like this
745 # to restore data:
746 mkdir /mnt/r7/btrbk
747 btrbk archive /mnt/rust1/btrbk /mnt/r7/btrbk
748 btrfs sub snap /mnt/r7/btrbk/LATEST /mnt/r7/d
749 mount /d
750 EOFOUTER
751 fi
752
753
754 echo 0 >~/.local/distro-begin
755 echo "$0: $(date): ending now"
756 echo "exiting with status 0"
757 exit 0